﻿package com{
	
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.geom.Rectangle;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.Loader;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	public class main extends MovieClip {
		
		private var stageMc;
		private var randomArr=[];
		private var activBegin=false;
		private var totalBox=0;
		private var currBox;
		private var hintBegin=0;
		private var posArr=[];
		private var imgCount=0;
		private var xmlData:XML;
		private var xmlLoader:URLLoader;
		private var imgLoader:Loader;
		private var currDropLoad=0;
		private var currDragLoad=0;
		private var DropLoad=0;
		private var DragLoad=0;
		private var isDragging:Boolean=false;
		private var correctDrop:Number = 0;
		private var checkCount = 0
		public function main() {
			
			stageMc=this;
			xmlLoader = new URLLoader();
			xmlLoader.load(new URLRequest("xml/data.xml"));
			xmlLoader.addEventListener(Event.COMPLETE, loadXml);
			
		}
		
		private function loadXml(eve:Event){
			xmlData = new XML(eve.target.data);
			var hintBtn = new hintMc();
			hintBtn.buttonMode=true;
			hintBtn.visible = false;
			hintBtn.addEventListener(MouseEvent.CLICK, showHint);
			stageMc.addChild(hintBtn);
			hintBtn.x=xmlData.imgData.@hintBtnX;
			hintBtn.y=xmlData.imgData.@hintBtnY;
			totalBox=Number(xmlData.imgData.children().length());
			for (var i=1; i<=totalBox; i++) {
				var xPos=xmlData.imgData.children()[i-1].@dragImgX;
				var yPos=xmlData.imgData.children()[i-1].@dragImgY;
				posArr.push({xpos:xPos, ypos:yPos});
			}
			for (i=1; i<=totalBox; i++) {
				imgCount=i;
				loadDragImages();
				loadDropImages()
			}
			
		}
		
		private function loadDragImages(){
			var myDragImgLoader:Loader = new Loader();

			myDragImgLoader.load(new URLRequest(xmlData.imgData.children()[imgCount-1].@dragImgURL));
			myDragImgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadDrag);
		}
		
		private function onLoadDrag(evt:Event){
			var myURL:String = evt.currentTarget.url;
			var myObjectNum = Number((myURL.split("dragImage")[1]).split(".")[0]);
			
			var dragMc = new MovieClip();
			var myBitMap = Bitmap(evt.target.content);
			myBitMap.smoothing=true;
			var myObjMc = new MovieClip();
			myObjMc.addChild(myBitMap);
			myObjMc.x = (myObjMc.x-(myObjMc.width/2));
			myObjMc.y = (myObjMc.y-(myObjMc.height/2));
			dragMc.addChild(myObjMc);
			dragMc.name = "dragMc"+myObjectNum;
			dragMc.Num=myObjectNum;
			dragMc.x=posArr[myObjectNum-1].xpos;
			dragMc.y=posArr[myObjectNum-1].ypos;
			stageMc.addChild(dragMc);
			currDragLoad++;
			if(currDragLoad>=totalBox){
				DragLoad=1;
				if (! activBegin) {
					if(DropLoad==1 && DragLoad==1){
						setDropIndex();
						activBegin=true;
					}
				}
			}
			
		}
		
		private function loadDropImages(){
			var myDropImgLoader:Loader = new Loader();
			myDropImgLoader.load(new URLRequest(xmlData.imgData.children()[imgCount-1].@dropImgURL));
			myDropImgLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadDrop);
		}
		
		private function onLoadDrop(evt:Event){
			var myDropURL:String = evt.currentTarget.url;
			var myDropObjectNum = Number((myDropURL.split("dropImage")[1]).split(".")[0]);
			var dropMc = new MovieClip();
			var myBitMap = Bitmap(evt.target.content);
			myBitMap.smoothing=true;
			var dropHintMc = new MovieClip();
			dropHintMc.name="dropHint";
			dropHintMc.addChild(myBitMap);
			dropHintMc.visible=false;
			dropMc.addChild(dropHintMc);
			dropHintMc.x = (dropHintMc.x-(dropHintMc.width/2));
			dropHintMc.y = (dropHintMc.y-(dropHintMc.height/2));
			dropMc.name = "dropMc"+myDropObjectNum;
			dropMc.x=xmlData.imgData.children()[myDropObjectNum-1].@dropImgX;
			dropMc.y=xmlData.imgData.children()[myDropObjectNum-1].@dropImgY;
			dropMc.smoothing = true;
			stageMc.addChild(dropMc);
			//stageMc.setChildIndex(dropMc, (stageMc.numChildren-1));
			var dropPlankMc = new plankMc();
			dropPlankMc.name="dropPlank";
			dropMc.addChild(dropPlankMc);
			dropMc.alpha=0.5;
			currDropLoad++;
			if(currDropLoad>=totalBox){
				DropLoad=1;
				if (! activBegin) {
					if(DropLoad==1 && DragLoad==1){
						setDropIndex();
						activBegin=true;
					}
				}
			}
		}
		
		private function setDropIndex(){
			for (var i=1; i<=totalBox; i++) {
				var dropMc=stageMc.getChildByName("dropMc"+i);
				stageMc.setChildIndex(dropMc, (stageMc.numChildren-1));
			}
			initActivity();
		}
		
		private function initActivity(){
			for (var i=1; i<=totalBox; i++) {
				var dropMc=stageMc.getChildByName("dropMc"+i);
				dropMc.Num=i;
				dropMc.mouseChildren=false;
				//dropMc.alpha=0;
				//dropMc.textMc.myTxt.text = i;
				dropMc.dropped=0;
			}
			//hintMc.buttonMode=true;
			//hintMc.addEventListener(MouseEvent.CLICK, showHint);
			//resetMc.buttonMode=true;
			reset_btn.addEventListener(MouseEvent.CLICK, resetFunc);
			randomize();
		}

		private function randomize() {
			var numArr=new Array();
			for(var j=1;j<=totalBox;j++){
				numArr.push(j);
			}
			randomArr=[];
			for (var i=1; i<=totalBox; i++) {
				randomArr.push(numArr.splice((Math.random()*numArr.length),1));
			}
			/*if (! activBegin) {
				duplicateItem();
				getPosValue();
				activBegin=true;
			}*/
			startActivity();
		}

		private function getPosValue() {
			for (var i=1; i<=totalBox; i++) {
				var xPos=this["dragMc"+i].x;
				var yPos=this["dragMc"+i].y;
				posArr.push({xpos:xPos, ypos:yPos});
			}
		}

		private function duplicateItem() {
			for (var i=1; i<=totalBox; i++) {
				var drag=this["dragMc"+i];
				//drag.name = "dragMc"+i;
				drag.Num=i;
				/*drag.textMc.myTxt.text = i;
				this.addChild(drag);*/
			}
		}

		private function startActivity() {
			for (var i=1; i<=totalBox; i++) {
				var drag=stageMc.getChildByName("dragMc"+randomArr[i-1]);
				/*drag.x = this["dragBg"+i].x;
				drag.y = this["dragBg"+i].y;*/
				//drag.Num=i;
				drag.x=posArr[i-1].xpos;
				drag.y=posArr[i-1].ypos;
				drag.xpos=drag.x;
				drag.ypos=drag.y;
				drag.buttonMode=true;
				drag.mouseChildren=false;
				drag.mouseEnabled=true;				
				//drag.addEventListener(MouseEvent.MOUSE_DOWN, onDrag);
			}
			addEventListener(MouseEvent.MOUSE_DOWN, onStageDown);
			addEventListener(MouseEvent.MOUSE_UP, onStageUp);			
		}
		
		private function onStageDown(obj:MouseEvent) {
			if(obj.target.name.indexOf("dragMc")==-1) return;
			for (var i=1; i<=totalBox; i++) {
				var drag=stageMc.getChildByName("dragMc"+i);
				if (drag.enabled
					&&mouseX>=drag.x-(drag.width/2)
					&&mouseX<=drag.x+(drag.width/2)
					&&mouseY>=drag.y-(drag.height/2)
					&&mouseY<=drag.y+(drag.height/2)) 
				{
					if(currBox!=drag){
						if(isDragging){
							currBox.stopDrag();
							currBox.x=currBox.xpos;
							currBox.y=currBox.ypos;
						}
						currBox=drag;
						onDrag(obj);
						break;
					}else
					{
					
							onDrag(obj);
						
						
					}
				}
			}
		}
		private function onStageUp(obj:MouseEvent) {
			if(!isDragging) return;
			for (var j=1; j<=totalBox; j++) {
				var dropMc=stageMc.getChildByName("dropMc"+j);
				if (mouseX>=dropMc.x-(dropMc.width/2)
					&&mouseX<=dropMc.x+(dropMc.width/2)
					&&mouseY>=dropMc.y-(dropMc.height/2)
					&&mouseY<=dropMc.y+(dropMc.height/2)) 
				{
					//trace("onStageUp:"+dropMc.name)
					onDrop();
					isDragging = false;
					break;
				}
			}
		}
		private function onDrag(obj:MouseEvent) {			
			isDragging = true;			
			currBox.parent.setChildIndex(currBox, (currBox.parent.numChildren-1));
			currBox.startDrag(false, new Rectangle(50, 50, 600, 450));									
		}

		private function onDrop() {			
			var dropTar=currBox.dropTarget.parent.parent;
			var setBack = 0;
			
			if (dropTar!=null||dropTar!=Stage) {
				if (dropTar.name.substr(0,6)=="dropMc") {
					if (currBox.Num==dropTar.Num) {
						correctDrop++;
						//trace(correctDrop)
					}
					currBox.x=dropTar.x;
					currBox.y = dropTar.y;
					
					//currBox.mouseEnabled=false;
					currBox.flg = 1
					dropTar.dropped=1;						
					currBox.stopDrag();
					//currBox.enabled = false;
					
					orderedDepths();
					checkAllDone();
				} else {
					setBack=1;
				}
			} else {
				setBack=1;
			}
			if (setBack==1) {
				currBox.stopDrag();
				currBox.x=currBox.xpos;
				currBox.y=currBox.ypos;	
				currBox=null;
			}
			//trace(dropTar.dropped)
		}

		private function orderedDepths() {
			for (var i=1; i<=totalBox; i++) {
				var drag=stageMc.getChildByName("dragMc"+i);
				drag.parent.setChildIndex(drag, (drag.parent.numChildren-1));
			}
			animMc.parent.setChildIndex(animMc, (animMc.parent.numChildren-1));
		}
		
		private function checkAllDone() {
			var alldone = 0;
			var checkCount = 0
			/*if(correctDrop == totalBox){
				alldone = 1;
			}
			if (alldone==1) {
				animMc.gotoAndPlay(2);
			}*/
			for (var i = 1; i <= totalBox; i++) {				
				if (Math.floor(stageMc.getChildByName("dragMc"+i).x) == Math.floor(xmlData.imgData.children()[i-1].@dropImgX))
				{
					checkCount++
					trace(checkCount+"   CHECK")
				}				
			}
			if (checkCount==totalBox) {
				animMc.gotoAndPlay(2);
			}
			
			
		}

		private function showHint(obj:MouseEvent) {
			if (hintBegin<20) {
				hintBegin++;
				var currHint=stageMc.getChildByName("dropMc"+hintBegin);
				while (currHint.dropped) {
					if (hintBegin<20) {
						hintBegin++;
						(hintBegin<=20)?currHint = stageMc.getChildByName("dropMc"+hintBegin):"";
					} else {
						break;
					}
				}
				var myHint = currHint.getChildByName("dropHint");
				var myPlank = currHint.getChildByName("dropPlank");
				myHint.visible=true;
				myPlank.visible=false;
				//currHint.gotoAndStop(2);
				//currHint.alpha=0.6;
			}
		}

		private function resetFunc(obj:MouseEvent) {
			isDragging=false;
			currBox=null;
			for (var i=1; i<=totalBox; i++) {
				var dragMc=stageMc.getChildByName("dragMc"+i);
				dragMc.enabled=true;
				var dropMc=stageMc.getChildByName("dropMc"+i);
				var myHint = dropMc.getChildByName("dropHint");
				var myPlank = dropMc.getChildByName("dropPlank");
				myHint.visible=false;
				myPlank.visible=true;
				//dropMc.gotoAndStop(1);
				//dropMc.alpha=0;
				dropMc.dropped=0;
			}
			hintBegin=0;
			randomize();
			animMc.gotoAndStop(1);
		}


	}
}