﻿package com{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Stage;

	import flash.geom.Rectangle;

	import flash.net.URLLoader;
	import flash.net.URLRequest;

	import flash.events.Event;
	import flash.events.MouseEvent;
	public class TimeSequence extends MovieClip {
		private var XMLObj:XML=new XML  ;
		private var ImageLoadersArray:Array=new Array  ;
		private var ImageIndex:Number=0;
		private var setIndex:Number=0;
		private var showSet:Number=0;
		private var TotalSets:Number;
		private var DragObj:MovieClip=new MovieClip  ;
		private var DragMcArray:Array=new Array();
		private var Loadingmc:Loading_mc=new Loading_mc  ;

		public function TimeSequence() {
			addChild(Loadingmc);
			Loadingmc.name="preloader";
			LoadActivityXML();
		}
		private function LoadActivityXML():void {
			var LoaderObj:URLLoader=new URLLoader  ;
			LoaderObj.load(new URLRequest("xml/NTO_F42.xml"));
			LoaderObj.addEventListener(Event.COMPLETE,onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void {
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Set.length();
			TotalSets=Len;
			for (var i:int=0; i<TotalSets; i++) {
				var obj:Object=new Object  ;
				obj.ImagesArray=new Array  ;
				obj.IdArray=new Array  ;
				ImageLoadersArray.push(obj);
			}
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			LoadImages();
		}
		private function LoadImages(e:Event=null):void {
			if (setIndex<TotalSets) {
				var ImCount:Number=XMLObj.Set[setIndex].Item.length();
				if (ImageIndex<ImCount) {
					if (XMLObj.Set[setIndex].Item[ImageIndex].@imageURL!=undefined&&XMLObj.Set[setIndex].Item[ImageIndex].@imageURL!="") {
						LoadImage(ImageIndex);
						ImageIndex++;
					} else {
						ImageLoadersArray.push(new Loader  );
						ImageIndex++;
						LoadImages();
					}
					if (getChildByName("preloader")) {
						BringPreloaderToFront();
						var percentage:int = int((setIndex/TotalSets)*100);
						if ( percentage < 100 ) {
							Loadingmc.loader_mc.gotoAndStop(percentage);
							Loadingmc.loader_mc.txt.text = "loading..."+percentage+"%";
						} 
					}
					
				}
			}
			if (ImageIndex==ImCount) {
				ImageIndex=0;
				if (setIndex<TotalSets) {
					setIndex++;
				}
				if (setIndex==TotalSets) {
					if (getChildByName("preloader")) {
						removeChild(Loadingmc);
					}
					AddImage(0);
				}
			}
		}
		private function LoadImage(ind:Number):void {
			var LoaderObj:Loader=new Loader  ;
			LoaderObj.load(new URLRequest(XMLObj.Set[setIndex].Item[ind].@imageURL));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,LoadImages);
			ImageLoadersArray[setIndex].ImagesArray.push(LoaderObj);
			ImageLoadersArray[setIndex].IdArray.push(XMLObj.Set[setIndex].Item[ind].@id);
		}
		private function AddImage(si:Number):void {
			DragMcArray=new Array();
			showSet=si;
			var Len:Number=XMLObj.Set[si].Item.length();
			for (var i:int=0; i<Len; i++) {
				if (getChildByName("drag_"+i)) {
					removeChild(getChildByName("drag_"+i));
				}

			}
			for (i=0; i<Len; i++) {
				if (ImageLoadersArray[si].ImagesArray[i].content) {
					var im:MovieClip=new MovieClip  ;
					im.name="drag_"+i;
					im.addChild(ImageLoadersArray[si].ImagesArray[i].content);
					addChild(im);
					im.id=ImageLoadersArray[si].IdArray[i];
					im.x=XMLObj.Set[si].Item[i].@imageX;
					im.y=XMLObj.Set[si].Item[i].@imageY;
					im.xpos=im.x;
					im.ypos=im.y;
					im.targetId=undefined;					
					if (i>0) {
						DragMcArray.push(im);
						im.mouseChildren=false;
						im.buttonMode=true;
						im.addEventListener(MouseEvent.MOUSE_DOWN,dragIt);
					}else
					{
						//im.addEventListener(MouseEvent.CLICK,Reset);
					}
				}
			}
			var mc=getChildByName("drag_0");
			CreateDropArea(mc.x,mc.y,mc.width,mc.height);
		}

		private function CreateDropArea(xpos:Number,ypos:Number,w:Number,h:Number):void {
			var Len:Number=XMLObj.Set[showSet].Item.length();
			var StartX:Number=xpos;
			var StartY:Number=ypos;
			
			for (var i:int=1; i<Len; i++) {
				if (getChildByName("drop_"+i)) {
					removeChild(getChildByName("drop_"+i));
				}
			}						
			for (i=1; i<Len; i++) {
				var mc:MovieClip=new MovieClip  ;
				var sh:Shape=new Shape  ;
				sh.graphics.lineStyle(XMLObj.Drop.@borderthickness,XMLObj.Drop.@bordercolor,XMLObj.Drop.@borderalpha);
				sh.graphics.beginFill(XMLObj.Drop.@fillcolor);
				sh.graphics.drawRect(0,0,w+Number(XMLObj.Drop.@borderthickness),h+Number(XMLObj.Drop.@borderthickness));
				sh.graphics.endFill();
				mc.addChild(sh);
				addChild(mc);
				mc.name="drop_"+i;
				mc.id=i;
				mc.mouseChildren=false;
				StartX+=mc.width+Number(XMLObj.Drop.@gap);
				mc.x=StartX;
				mc.y=StartY;

			}

		}
		private function dragIt(e:MouseEvent):void {
			if(getChildByName("feedback"))
			{
				removeChild(getChildByName("feedback"));
			}
			var Tar=e.currentTarget;
			DragObj=Tar;
			setChildIndex(DragObj,numChildren-1);
			Tar.startDrag(false,new Rectangle(0,0,stage.stageWidth-Tar.width,stage.stageHeight-Tar.height));
			Tar.addEventListener(MouseEvent.MOUSE_UP,dropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,dropIt);
		}
		private function dropIt(e:MouseEvent):void {
			if (DragObj) {
				var tar=DragObj.dropTarget;
				if (tar!=null&&tar.parent&&tar.parent.name.indexOf("drop")!=-1) {
					tar=tar.parent;
					DragObj.x=tar.x+Number(XMLObj.Drop.@borderthickness)-1;
					DragObj.y=tar.y+Number(XMLObj.Drop.@borderthickness)-1;
					DragObj.targetId=tar.id;
				} else if (tar!=null&&tar.name.indexOf("drop")!=-1) {
					DragObj.x=tar.x+Number(XMLObj.Drop.@borderthickness)-1;
					DragObj.y=tar.y+Number(XMLObj.Drop.@borderthickness)-1;
					DragObj.targetId=tar.id;
				} else {
					DragObj.targetId=undefined;
					DragObj.x=DragObj.xpos;
					DragObj.y=DragObj.ypos;
				}
				DragObj.stopDrag();
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
				DragObj=new MovieClip();
			}
			Validate();
		}
		private function Validate():void
		{
			var Count:Number=0;
			var correctStr:String="";
			var selectedStr:String="";
			for(var i:int=0;i<DragMcArray.length;i++)
			{
				correctStr+=XMLObj.Set[showSet].Item[(i+1)].@id;
				if(DragMcArray[i].targetId!=undefined)
				{
					selectedStr+=String(DragMcArray[i].targetId);
					Count++;
				}				
			}
			if(Count==DragMcArray.length)
			{
				if(correctStr==selectedStr)
				{
					var mc:correct_mc=new correct_mc();
					addChild(mc);
					mc.name="feedback";
					mc.x=XMLObj.FeedbackPosition.@xpos;
					mc.y=XMLObj.FeedbackPosition.@ypos;
				}else
				{
					var wmc:wrong_mc=new wrong_mc();
					addChild(wmc);
					wmc.name="feedback";
					wmc.x=XMLObj.FeedbackPosition.@xpos;
					wmc.y=XMLObj.FeedbackPosition.@ypos;
				}
			}
		}
		private function onReset(e:MouseEvent= null):void
		{
			if(showSet<(TotalSets-1))
			{
				showSet++;
			}else
			{
				showSet=0;
			}
				if(getChildByName("feedback"))
			{
				removeChild(getChildByName("feedback"));
			}
			AddImage(showSet);
		}
		private function BringPreloaderToFront():void {
			setChildIndex(Loadingmc,numChildren-1);
		}
	}
}