﻿package com
{
	import flash.display.MovieClip;	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.geom.Rectangle;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFormatAlign;
	public class LadyBird extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var drop:bird=new bird();
		private var DragObj:MovieClip=new MovieClip();		
		private var DropObjArray:Array=new Array();
		private var Col1Array:Array=new Array();
		private var Col2Array:Array=new Array();
		private var AnswerTextArray:Array=new Array();
		private var sa:showanswer=new showanswer();
		private var ha:hideanswer=new hideanswer();
		private var mc:MovieClip
		
		public function LadyBird()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F43.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			AddLadyBird();
			AddDots();
			AddText();
			AddButtons();
			AddAnswerText();
		}
		private function onReset(eve:MouseEvent=null):void{
			for(var i:int=0;i< XMLObj.Dots.Dot.length();i++)
			{
				var mc = getChildByName("mc_"+Number(i))
				mc.x=XMLObj.Dots.Dot[i].@xpos;
				mc.y=XMLObj.Dots.Dot[i].@ypos;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				
			}
		    Col1Array=new Array();
			Col2Array=new Array();
			AnswerTextArray[1].htmlText=Col1Array.length;
			AnswerTextArray[2].htmlText=Col2Array.length;
			AnswerTextArray[3].htmlText=Col1Array.length+Col2Array.length;
			ha.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			

			
		}
		private function AddLadyBird():void
		{
			addChild(drop);
			drop.x=XMLObj.LadyBird.@xpos;
			drop.y=XMLObj.LadyBird.@ypos;
			DropObjArray.push(drop.left);
			DropObjArray.push(drop.right);
		}
		private function AddDots():void
		{
			for(var i:int=0;i<XMLObj.Dots.Dot.length();i++)
			{
				mc=new dot();
				mc.index=i;
				
				mc.x=XMLObj.Dots.Dot[i].@xpos;
				mc.y=XMLObj.Dots.Dot[i].@ypos;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				mc.name = "mc_"+i
				addChild(mc);
				mc.buttonMode=true;
				mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
		}
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		private function AddText():void
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			
			
			TxtFld.htmlText=XMLObj.AnswerText;
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.AnswerText.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.AnswerText.@FontSize;
			TF.color=XMLObj.AnswerText.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=Number(XMLObj.AnswerText.@xpos);
			TxtFld.y=Number(XMLObj.AnswerText.@ypos);
			AnswerTextArray.push(TxtFld);
			TxtFld.visible=false;
			addChild(TxtFld);
		}
		private function AddButtons():void
		{
			
			sa.x=XMLObj.ShowAnswer.@xpos;
			sa.y=XMLObj.ShowAnswer.@ypos;
			addChild(sa);
			sa.addEventListener(MouseEvent.CLICK,showAnswer);
			
			ha.mouseEnabled=false;
			ha.alpha=.5;
			ha.x=XMLObj.HideAnswer.@xpos;
			ha.y=XMLObj.HideAnswer.@ypos;
			addChild(ha);
			ha.addEventListener(MouseEvent.CLICK,hideAnswer);
		}
		private function AddAnswerText():void
		{
			var Num:Number=XMLObj.Answers.Answer.length();
			for(var i:int=0;i<Num;i++)
			{
				var TxtFld:TextField=new TextField();
				TxtFld.name="txt_"+i;
				TxtFld.width=XMLObj.Answers.@width;
				TxtFld.height=XMLObj.Answers.@height;
				TxtFld.selectable=false;
				TxtFld.multiline=false;
				//TxtFld.border=true;				
				
				
				TxtFld.antiAliasType=AntiAliasType.ADVANCED;
				
				var TF:TextFormat=new TextFormat();
				TF.align=TextFormatAlign.CENTER;
				
				var FontC=getDefinitionByName(XMLObj.AnswerText.@noFont) as Class;
				var newFont:Font=new FontC();
				
				TF.font=newFont.fontName;	
				TF.size=XMLObj.AnswerText.@FontSize;
				TF.color=XMLObj.Answers.@FontColor;
	
				TxtFld.defaultTextFormat=TF;	
				TxtFld.htmlText="0";
				TxtFld.embedFonts=true;
				
				TxtFld.x=Number(XMLObj.Answers.Answer[i].@xpos);
				TxtFld.y=Number(XMLObj.Answers.Answer[i].@ypos);
				
				addChild(TxtFld);
				TxtFld.visible=false;
				AnswerTextArray.push(TxtFld);
			}
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			setChildIndex(DragObj,numChildren-1);
			DragObj.startDrag(false,new Rectangle(0,0,760-DragObj.width,530-DragObj.height));
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			
			for(var i:int=0;i<Col1Array.length;i++)
			{
				if(Col1Array[i].index==DragObj.index)
				{
					Col1Array.splice(i,1);
					break;
				}
			}
			for(i=0;i<Col2Array.length;i++)
			{
				if(Col2Array[i].index==DragObj.index)
				{
					Col2Array.splice(i,1);
					break;
				}
			}			
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{				
				DragObj.stopDrag();
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				var cnt:Number=0;
				for(var i:int=0;i<DropObjArray.length;i++)
				{
					if(DragObj.hitTestObject(DropObjArray[i]))
					{
						cnt++;
						if(i==0)
						{
							Col1Array.push(DragObj);
						}else
						{
							Col2Array.push(DragObj);
						}
						 break;
					}
				}
				if(cnt==0)
				{
					DragObj.x=DragObj.xpos;
					DragObj.y=DragObj.ypos;
				}
				DragObj=new MovieClip();
			}
			AnswerTextArray[1].htmlText=Col1Array.length;
			AnswerTextArray[2].htmlText=Col2Array.length;
			AnswerTextArray[3].htmlText=Col1Array.length+Col2Array.length;
		}
		private function showAnswer(e:MouseEvent):void
		{
			sa.mouseEnabled=false;
			ha.mouseEnabled=true;
			sa.alpha=.5;
			ha.alpha=1;
			for(var i:int=0;i<AnswerTextArray.length;i++)
			{
				AnswerTextArray[i].visible=true;
			}
		}
		private function hideAnswer(e:MouseEvent):void
		{
			sa.mouseEnabled=true;
			ha.mouseEnabled=false;
			sa.alpha=1;
			ha.alpha=.5;
			for(var i:int=0;i<AnswerTextArray.length;i++)
			{
				AnswerTextArray[i].visible=false;
			}
		}
	}
}