﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import fl.transitions.easing.Regular;
	
	import fl.transitions.TweenEvent;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFormatAlign;
	public class Matching extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var CellsArray:Array=new Array();
		private var XposArray:Array=new Array();
		private var YposArray:Array=new Array();
		private var cardTween:Tween;
		private var flipItem:*;
		private var FlipCardsArray:Array=new Array();
		private var FlipCounter:Number=0;
		
		private var Btn1:Num0_5=new Num0_5();
		private var Btn2:Num0_10=new Num0_10();
		private var Btn3:Num0_20=new Num0_20();
		private var Grid_no:Number=3;
		private var Feedback:great=new great();
		private var cellMode:Number
		public function Matching()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F50.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);

			addChild(Btn1);
			addChild(Btn2);
			addChild(Btn3);
			
			Btn1.x=XMLObj.Buttons.Btn1.@xpos;
			Btn1.y=XMLObj.Buttons.Btn1.@ypos;
			Btn2.x=XMLObj.Buttons.Btn2.@xpos;
			Btn2.y=XMLObj.Buttons.Btn2.@ypos;
			Btn3.x=XMLObj.Buttons.Btn3.@xpos;
			Btn3.y=XMLObj.Buttons.Btn3.@ypos;
			Btn1.mouseChildren = false;
			Btn2.mouseChildren = false;
			Btn3.mouseChildren = false;
			Btn1.buttonMode = true;
			Btn2.buttonMode = true;
			Btn3.buttonMode = true;
			addEventlistener(Btn1);
			addEventlistener(Btn2);
			Btn3.gotoAndStop(3);
			Btn1.addEventListener(MouseEvent.CLICK,Grid1);
			Btn2.addEventListener(MouseEvent.CLICK,Grid2);
			Btn3.addEventListener(MouseEvent.CLICK,Grid3);
			reset_btn.addEventListener(MouseEvent.CLICK, Reset);
			cellMode = 2
			ShowGrid3();	
			Btn1.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
		}
		private function addEventlistener(target_mc):void{
			target_mc.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
			target_mc.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
		}
		private function removeEventlistener(target_mc):void{
			target_mc.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
			target_mc.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout)
		}
		private function onmouseover(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(2);
		}
		private function onmouseout(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(1);
		}
		private function onmousedown(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(3);
		}
		private function onmouseup(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(1);
		}
		private function ShowGrid1():void
		{
			var rows:Number=Number(String(XMLObj.Cell.@dim1).substr(0,1));
			var cols:Number=Number(String(XMLObj.Cell.@dim1).substr(2,1));
			var initX:Number=Number(XMLObj.Cell.@start1X);
			var initY:Number = Number(XMLObj.Cell.@start1Y);
			var init:Number=Number(String(XMLObj.Cell.@range1).split("-")[0]);
			var Num:Number=Number(String(XMLObj.Cell.@range1).split("-")[1]);
			
			CreateGrid(rows,cols,initX,initY,Num,init);
		}
		private function ShowGrid2():void
		{
			var rows:Number=Number(String(XMLObj.Cell.@dim2).substr(0,1));
			var cols:Number=Number(String(XMLObj.Cell.@dim2).substr(2,1));
			var initX:Number=Number(XMLObj.Cell.@start2X);
			var initY:Number = Number(XMLObj.Cell.@start2Y);
			var init:Number=Number(String(XMLObj.Cell.@range2).split("-")[0]);
			var Num:Number=Number(String(XMLObj.Cell.@range2).split("-")[1]);
			
			CreateGrid(rows,cols,initX,initY,Num,init);
		}
		private function ShowGrid3():void
		{
			var rows:Number=Number(String(XMLObj.Cell.@dim3).substr(0,1));
			var cols:Number=Number(String(XMLObj.Cell.@dim3).substr(2,1));
			var initX:Number=Number(XMLObj.Cell.@start3X);
			var initY:Number=Number(XMLObj.Cell.@start3Y);
			var Num:Number=Number(String(XMLObj.Cell.@range3).split("-")[1]);
			var init:Number=Number(String(XMLObj.Cell.@range3).split("-")[0]);
			CreateGrid(rows,cols,initX,initY,Num,init);
		}
		private function CreateGrid(Num_rows:Number,Num_cols:Number,StartX:Number,StartY:Number,Len:Number,fromInd:Number):void
		{
			FlipCardsArray=new Array();
			var TotalCells=Num_rows*Num_cols;
			var InitX:Number=StartX;
			var InitY:Number=StartY;
			XposArray=new Array();
			YposArray=new Array();
			trace(fromInd)
			for(var i:int=0;i<Num_rows;i++)
			{
				for(var j:int=0;j<Num_cols;j++)
				{
					var mc:MovieClip=new MovieClip();
					var child:MovieClip=new MovieClip();
					mc.name="cell_"+i+"_"+j;
					child.name="child";
					
					var sh:Shape=new Shape();
					sh.name="card";
					sh.graphics.lineStyle(XMLObj.Cell.@borderthickness,XMLObj.Cell.@bordercolor,1)
					sh.graphics.beginFill(XMLObj.Cell.@fillcolor,1);
					sh.graphics.drawRect(-Math.round(Number(XMLObj.cellSettings.set[cellMode].@width)/2),-Math.round(Number(XMLObj.cellSettings.set[cellMode].@height)/2),Number(XMLObj.cellSettings.set[cellMode].@width),Number(XMLObj.cellSettings.set[cellMode].@height));
					sh.graphics.endFill();
					
					var sh1:Shape=new Shape();
					sh1.graphics.lineStyle(XMLObj.Cell.@borderthickness,XMLObj.Cell.@bordercolor,1)
					sh1.graphics.beginFill(XMLObj.Cell.@bgcolor,1);
					sh1.graphics.drawRect(-Math.round(Number(XMLObj.cellSettings.set[cellMode].@width)/2),-Math.round(Number(XMLObj.cellSettings.set[cellMode].@height)/2),Number(XMLObj.cellSettings.set[cellMode].@width),Number(XMLObj.cellSettings.set[cellMode].@height));
					sh1.graphics.endFill();
					
					mc.addChild(sh1);
					mc.addChild(child);
					mc.addChild(sh);
					
					addChild(mc);
					mc.mouseChildren=false;
					mc.buttonMode=true;
					CellsArray.push(mc);
					mc.addEventListener(MouseEvent.CLICK,FlipIt);
					
					mc.x=StartX+Number(XMLObj.cellSettings.set[cellMode].@width)/2;
					mc.y=StartY+Number(XMLObj.cellSettings.set[cellMode].@height)/2;
					StartX+=sh.width-Number(XMLObj.Cell.@borderthickness);
					
					XposArray.push(mc.x);
					YposArray.push(mc.y);
					
				}
				StartX=InitX;
				StartY+=sh.height-Number(XMLObj.Cell.@borderthickness);
			}
			var Counter:Number=0;
			
			for(i=fromInd;i<=Len;i++)
			{
				var txt:TextField=AddText(i,XMLObj.Numbers.Number[i]);
				var main=CellsArray[Counter].getChildByName("child");		
				CellsArray[Counter].id=i;
				txt.x=-(txt.width)/2;
				txt.y=-(txt.height)/2;
				main.addChild(txt);
				Counter++;
			}
			for(i=fromInd;i<=Len;i++)
			{
				txt=AddText(i,XMLObj.Words.Word[i]);
				main=CellsArray[Counter].getChildByName("child");	
				CellsArray[Counter].id=i;
				txt.x=-(txt.width)/2;
				txt.y=-(txt.height)/2;
				main.addChild(txt);
				Counter++;
			}
			for(i=fromInd;i<=Len;i++)
			{
				var cla=getDefinitionByName("dot_"+i) as Class;
				var dot=new cla();
				main=CellsArray[Counter].getChildByName("child");	
				CellsArray[Counter].id=i;
				dot.x=-(dot.width)/2;
				dot.y=-(dot.height)/2;
				main.addChild(dot);
				Counter++;
			}
			var itemsArray:Array=new Array();
			for(i=0;i<Counter;i++)
			{
				itemsArray.push(CellsArray[i]);
			}
			var arr2:Array = []; 
			while (itemsArray.length > 0) {
			arr2.push(itemsArray.splice(Math.round(Math.random() * (itemsArray.length - 1)), 1)[0]);
			}
			for(i=Counter;i<TotalCells;i++)
			{
				var item=CellsArray[i].getChildByName("card")
				item.visible = false;
				CellsArray[i].visible = false
				CellsArray[i].buttonMode=false;
				CellsArray[i].removeEventListener(MouseEvent.CLICK,FlipIt);
			}
			
			for(i=0;i<Counter;i++)
			{
				arr2[i].x=XposArray[i];
				arr2[i].y=YposArray[i];
			}
		}
		private function AddText(CurrentIndex:Number,Str:String):TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt"+CurrentIndex;
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			
			TxtFld.htmlText=Str;
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC;
			
			if(isNaN(Number(Str))){
				TF.size=XMLObj.Text.@wordFontSize;
				FontC=getDefinitionByName(XMLObj.Text.@FontId) as Class;
			}else{
				TF.size=XMLObj.Text.@numeralFontSize;
				FontC=getDefinitionByName(XMLObj.Text.@numberFont) as Class;
			}
			var newFont:Font=new FontC();			
			TF.font=newFont.fontName;	
			TF.color=XMLObj.Text.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			return TxtFld;
		}
		private function FlipIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			StatusAllItems(false);
			FlipCardsArray.push(tar);
			if(getChildByName("great"))
			{
				removeChild(Feedback);
			}
			tar.opened=true;
			tar.mouseEnabled=false;
			flipItem=tar.getChildByName("card");
			var cardTween=new Tween(flipItem,"scaleX", Strong.easeOut,-1,1,Number(XMLObj.card.@flipspeed),true);			
			cardTween.addEventListener(TweenEvent.MOTION_CHANGE,onChange);
			cardTween.start();

		}
		private function onChange(e:TweenEvent):void
		{
			var  tar=e.currentTarget;
			if(flipItem.scaleX>=0)
			{
				
				//tar.removeEventListener(TweenEvent.MOTION_CHANGE,onChange);
				flipItem.visible=false;
				if(FlipCardsArray.length<3)
				{
					StatusAllItems(true);
				}
				
			}
			if(flipItem.scaleX>=1)
			{
				tar.stop();
				tar.removeEventListener(TweenEvent.MOTION_CHANGE,onChange);
				onFinish();
			}
			//tar.addEventListener(TweenEvent.MOTION_FINISH,onFinish);
		}	
		private function onFinish(e:TweenEvent=null):void
		{
			if(FlipCardsArray.length==3)
			{
				var cnt:int=0;
				for(var i:int=0;i<FlipCardsArray.length;i++)
				{
					var id:Number=FlipCardsArray[0].id;
					if(FlipCardsArray[i].id==id)
					{
						cnt++;
					}
				}//trace(cnt)
				if(cnt!=3)
				{
					var fl1=FlipCardsArray[0].getChildByName("card");
					var tw1:Tween=new Tween(fl1,"scaleX",Strong.easeOut,-1,1,Number(XMLObj.card.@flipspeed),false);	
					fl1.visible=true;
					FlipCardsArray[0].opened=false;
					
					var fl2=FlipCardsArray[1].getChildByName("card");
					var tw2:Tween=new Tween(fl2,"scaleX",Strong.easeOut,-1,1,Number(XMLObj.card.@flipspeed),false);	
					fl2.visible=true;
					FlipCardsArray[1].opened=false;				
					
					var fl3=FlipCardsArray[2].getChildByName("card");
					var tw3:Tween=new Tween(fl3,"scaleX",Strong.easeOut,-1,1,Number(XMLObj.card.@flipspeed),false);	
					fl3.visible=true;
					FlipCardsArray[2].opened=false;
					
					tw1.start();
					tw2.start();
					tw3.start();
					tw1.addEventListener(TweenEvent.MOTION_FINISH,setCounter);	
					tw2.addEventListener(TweenEvent.MOTION_FINISH,setCounter);
					tw3.addEventListener(TweenEvent.MOTION_FINISH,setCounter);
					StatusAllItems(false);
				}
				if(cnt==3)
				{
					FlipCardsArray[0].opened=true;
					FlipCardsArray[1].opened=true;
					FlipCardsArray[2].opened=true;
					Feedback.name="great";
					addChild(Feedback);
					Feedback.x=XMLObj.Feedback.@xpos;
					Feedback.y=XMLObj.Feedback.@ypos;
					StatusAllItems(true);
				}
				FlipCardsArray=new Array();
				
			}						
		}	
		private function setCounter(e:TweenEvent):void
		{
			FlipCounter++;
			if(FlipCounter==3)
			{
				
				FlipCounter=0;
				StatusAllItems(true);
			}
		}
		private function StatusAllItems(Status:Boolean):void
		{
			for(var i:int=0;i<CellsArray.length;i++)
			{
				if(!CellsArray[i].opened)
				{
					CellsArray[i].mouseEnabled=Status;
				}else
				{
					CellsArray[i].mouseEnabled=false;
				}
			}
		}
		private function RemoveGrid():void
		{
			for(var i:int=0;i<CellsArray.length;i++)
			{
				removeChild(CellsArray[i]);
			}
			CellsArray=new Array();
		}
		private function Grid1(e:MouseEvent):void
		{
			selectedstate(Btn1)
			normalstate(Btn2);
			normalstate(Btn3)
			removeEventlistener(Btn1);
			addEventlistener(Btn2);
			addEventlistener(Btn3);
			Grid_no = 1
			cellMode = 0
			RemoveGrid();
			ShowGrid1();
		}
		private function selectedstate(Btn):void{
			Btn.gotoAndStop(3);

		}
		private function normalstate(Btn):void{
			Btn.gotoAndStop(1);

		}
		private function Grid2(e:MouseEvent):void
		{
			Grid_no=2
			selectedstate(Btn2)
			normalstate(Btn1);
			normalstate(Btn3)
			removeEventlistener(Btn2);
			addEventlistener(Btn1);
			addEventlistener(Btn3);
			cellMode = 1
			RemoveGrid();
			ShowGrid2();
		}
		private function Grid3(e:MouseEvent):void
		{
			Grid_no=3;
			selectedstate(Btn3)
			normalstate(Btn1);
			normalstate(Btn2)
			removeEventlistener(Btn3);
			addEventlistener(Btn1);
			addEventlistener(Btn2);
			RemoveGrid();
			cellMode = 2
			ShowGrid3();
		}
		private function Reset(e:MouseEvent=null):void
		{
			RemoveGrid();
			if(getChildByName("great"))
			{
				removeChild(Feedback);
			}
			if(Grid_no==1)
			{
				ShowGrid1();
			}
			if(Grid_no==2)
			{
				ShowGrid2();
			}
			if(Grid_no==3)
			{
				ShowGrid3();
			}
		}
	}
}