﻿package com
{
	import flash.display.MovieClip;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class OldManPoem extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var CurrentIndex:Number=0;
		private var TotalPoems:Number;
			
		public function OldManPoem()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/poem.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Poems.Poem.length();
			TotalPoems=Len;
			
			
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			AddText();
		}
		public function onReset(evt:MouseEvent = null ) {
			
			CurrentIndex=0;
			AddText();
			
		}
		private function AddText():void
		{
			if(getChildByName("poem_txt"))
			{
				removeChild(getChildByName("poem_txt"));
			}
			var TxtFld:TextField=new TextField();
			TxtFld.name="poem_txt";
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=true;
			
			
			TxtFld.htmlText=XMLObj.Poems.Poem[CurrentIndex];
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Poems.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Poems.@FontSize;
			//TF.color=XMLObj.Poems.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=XMLObj.Poems.Poem[CurrentIndex].@xpos;
			TxtFld.y=XMLObj.Poems.Poem[CurrentIndex].@ypos;
			addChild(TxtFld);
		}
	}
}