﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
		
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class Colours extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var TotalColours:Number;
			
		public function Colours()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F10.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Circles.Circle.length();
			TotalColours=Len;
			
			DrawCircles();
		}
		
		private function DrawCircles():void
		{
			for(var i:int=0;i<TotalColours;i++)
			{
				var sh:Shape=new Shape();
				sh.graphics.lineStyle(XMLObj.Circles.Circle[i].@borderthick,XMLObj.Circles.Circle[i].@bordercolour,0.3);
				sh.graphics.beginFill(XMLObj.Circles.Circle[i].@fillcolour);
				sh.graphics.drawCircle(XMLObj.Circles.Circle[i].@xpos,XMLObj.Circles.Circle[i].@ypos,XMLObj.Circles.Circle[i].@radius);
				sh.graphics.endFill();
				addChild(sh);
				AddText(i);
			}
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
		}
		
		public function onReset(evt:MouseEvent = null ):void {

		}
		
		private function AddText(CurrentIndex:Number):void
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="Circle_txt"+CurrentIndex;
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=true;
			
			
			TxtFld.htmlText=XMLObj.Circles.Circle[CurrentIndex].@colorLabel;
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Circles.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Circles.@FontSize;
			TF.color=XMLObj.Circles.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			//TxtFld.border=true;
			
			TxtFld.x=Number(XMLObj.Circles.Circle[CurrentIndex].@xpos)-TxtFld.width/2;
			TxtFld.y=Number(XMLObj.Circles.Circle[CurrentIndex].@ypos)+Number(XMLObj.Circles.Circle[CurrentIndex].@radius)+Number(XMLObj.Circles.Circle[CurrentIndex].@gap_bw_circle_txt);
			//trace(TxtFld.y);
			addChild(TxtFld);
		}
	}
}