﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.display.Shape;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	
	public class NumbersToFive extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var ImageIndex:Number=0;
		private var TotalColumns:Number;
		private var Loadingmc:Loading_mc=new Loading_mc();	
		
		public function NumbersToFive()
		{
			addChild(Loadingmc);
			Loadingmc.name="preloader";
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F11.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Table.Column.length();
			TotalColumns=Len;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			CreateTable();
			AddText();
			LoadImages();
		}
		public function onReset(evt:MouseEvent = null ):void {

		}
		private function LoadImages(e:Event=null):void
		{
			var RowCount:Number=XMLObj.Table.Column[2].Row.length();
			if(ImageIndex<RowCount)
			{
				if(XMLObj.Table.Column[2].Row[ImageIndex].@imageURL!=undefined && XMLObj.Table.Column[2].Row[ImageIndex].@imageURL!="")
				{
					LoadImage(ImageIndex);
					ImageIndex++;
				}else
				{
					ImageIndex++;
					LoadImages();
				}
				if(getChildByName("preloader"))
				{
					BringPreloaderToFront();
				}
				var percentage:int = int((ImageIndex/RowCount)*100);
				if ( percentage < 100 ) {
					Loadingmc.loader_mc.gotoAndStop(percentage);
					Loadingmc.loader_mc.txt.text = "loading..."+percentage+"%";
				} 
			}
			if(ImageIndex==RowCount)
			{
				if(getChildByName("preloader"))
				{
					removeChild(Loadingmc);
				}
			}
			
		}
		private function LoadImage(ind:Number):void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(XMLObj.Table.Column[2].Row[ind].@imageURL));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,LoadImages);
			addChild(LoaderObj);
			LoaderObj.x=XMLObj.Table.Column[2].Row[ind].@imageX;
			LoaderObj.y=XMLObj.Table.Column[2].Row[ind].@imageY;
			
			
		}
		private function AddText():void
		{
			for(var i:int=0;i<TotalColumns-1;i++)
			{
				for(var j:int=0;j<XMLObj.Table.Column[i].Row.length();j++)
				{		
					var TxtFld:TextField=new TextField();
					TxtFld.autoSize="left";
					TxtFld.selectable=false;
					TxtFld.multiline=false;					
					
					TxtFld.htmlText=XMLObj.Table.Column[i].Row[j].@text;
					TxtFld.antiAliasType=AntiAliasType.ADVANCED;
					
					var TF:TextFormat=new TextFormat();
					var FontC=getDefinitionByName(XMLObj.Table.Column[i].@FontId) as Class;
					var newFont:Font=new FontC();
					
					TF.font=newFont.fontName;	
					TF.size=XMLObj.Table.@FontSize;
					TF.color=XMLObj.Table.@FontColor;
		
					TxtFld.setTextFormat(TF);	
					TxtFld.embedFonts=true;
					
					TxtFld.x=XMLObj.Table.Column[i].Row[j].@xpos;
					TxtFld.y=XMLObj.Table.Column[i].Row[j].@ypos;
					addChild(TxtFld);
				}
			}
			BringPreloaderToFront();
		}
		private function CreateTable():void
		{
			var InitX:Number=XMLObj.Table.@xpos;
			var InitY:Number=XMLObj.Table.@ypos;
			var StartX:Number=InitX;
			var StartY:Number=InitY;
			for(var i:int=0;i<TotalColumns;i++)
			{
				for(var j:int=0;j<XMLObj.Table.Column[i].Row.length();j++)
				{
					var sh:Shape=new Shape();
					sh.graphics.lineStyle(2,0x000000,0.3);
					sh.graphics.beginFill(0xffffff);
					sh.graphics.drawRect(StartX,StartY,XMLObj.Table.@cellWidth,XMLObj.Table.@cellHeight);
					sh.graphics.endFill();
					addChild(sh);
					StartY+=Number(XMLObj.Table.@cellHeight);
				}
				StartX+=Number(XMLObj.Table.@cellWidth);
				StartY=InitY;
			}
			BringPreloaderToFront();
		}
		private function BringPreloaderToFront():void
		{
			setChildIndex(Loadingmc,numChildren-1);
		}
	}
}