﻿package com{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;

	public class DotCardNumberMatching {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var pageArr:Array;
		private var btnArr:Array;
		private var currLeftPage:Number;
		private var currRightPage:Number;
		private var isDragging:Boolean;
		private var contentType:Number;
		private var fromRange:Number;
		private var toRange:Number;
		private var modes:String;
		private var STAGE_WIDTH:Number = 760
		private var STAGE_HEIGHT:Number = 530
		public function DotCardNumberMatching(target:MovieClip):void {
			targetClip=target;
			targetClip.visible = false;
			xmlData = new XML();
			pageArr = new Array();
			btnArr = new Array();
			isDragging = false;
			contentType = -1;
			currLeftPage = -1;
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}	
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;
			if(val){
				targetClip.reset_btn.alpha = 1;
				btnArr = [];
				btnArr.push(targetClip.shuffleBtn);
				btnArr.push(targetClip.settingsBtn);
				btnArr.push(targetClip.fromUpBtn);
				btnArr.push(targetClip.fromDownBtn);
				btnArr.push(targetClip.toUpBtn);
				btnArr.push(targetClip.toDownBtn);
				btnArr.push(targetClip.rndAnyBtn);
				btnArr.push(targetClip.rndNumBtn);
				btnArr.push(targetClip.rndDotBtn);
				for(var i=0;i<btnArr.length;i++){
					var btn:MovieClip = btnArr[i] as MovieClip;
					btn.mouseChildren = false;
					btn.buttonMode = true;
				}
				targetClip.rndBtn.visible = false;   
				targetClip.fromUpBtn.visible = false;
				targetClip.fromDownBtn.visible = false;
				targetClip.toUpBtn.visible = false;
				targetClip.toDownBtn.visible = false;
				targetClip.rndAnyBtn.visible = false;
				targetClip.rndNumBtn.visible = false;
				targetClip.rndDotBtn.visible = false;
				targetClip.fromTxt.visible = false;
				targetClip.toTxt.visible = false;
				targetClip.titleClip.visible = false;
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){reset();});
				targetClip.fromUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.fromDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.toUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
				targetClip.toDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);	
				
				targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
				targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_DOWN,function(e:MouseEvent){
			  		e.target.gotoAndStop(3);				
				});
				targetClip.shuffleBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					e.target.gotoAndStop(1);
					shuffle();					
				});
				targetClip.settingsBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
				targetClip.settingsBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.settingsBtn.addEventListener(MouseEvent.MOUSE_DOWN,function(e:MouseEvent){
			  		e.target.gotoAndStop(3);				
				});
				targetClip.settingsBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					e.target.gotoAndStop(1);
					targetClip.rndBtn.visible = !targetClip.rndBtn.visible;   
					targetClip.fromUpBtn.visible = !targetClip.fromUpBtn.visible;
					targetClip.fromDownBtn.visible = !targetClip.fromDownBtn.visible;
					targetClip.toUpBtn.visible = !targetClip.toUpBtn.visible;
					targetClip.toDownBtn.visible = !targetClip.toDownBtn.visible;
				  	targetClip.rndAnyBtn.visible = !targetClip.rndAnyBtn.visible;
				  	targetClip.rndNumBtn.visible = !targetClip.rndNumBtn.visible;
				   	targetClip.rndDotBtn.visible = !targetClip.rndDotBtn.visible;
					targetClip.fromTxt.visible = !targetClip.fromTxt.visible;
					targetClip.toTxt.visible = !targetClip.toTxt.visible;
					targetClip.titleClip.visible = !targetClip.titleClip.visible;
			  	});
				targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
				targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_DOWN,function(e:MouseEvent){
					e.target.gotoAndStop(3);
				});
				targetClip.rndAnyBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					modes = e.target.name;
					targetClip.rndAnyBtn.gotoAndStop(3);
					targetClip.rndAnyBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndAnyBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndNumBtn.gotoAndStop(1);
					targetClip.rndDotBtn.gotoAndStop(1);
					shuffle();
				});
				targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
				targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_DOWN,function(e:MouseEvent){
					e.target.gotoAndStop(3);
				});
				targetClip.rndNumBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					modes = e.target.name;
					
					targetClip.rndNumBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndNumBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndAnyBtn.gotoAndStop(1);
					targetClip.rndNumBtn.gotoAndStop(3);
					targetClip.rndDotBtn.gotoAndStop(1);
					shuffle();
				});
				targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
				targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.rndDotBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					e.target.gotoAndStop(3);
				});
				
				targetClip.rndDotBtn.addEventListener(MouseEvent.MOUSE_UP,function(e:MouseEvent){
					modes = e.target.name;
					targetClip.rndDotBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndDotBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndAnyBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseOver)
					targetClip.rndNumBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.rndAnyBtn.gotoAndStop(1);
					targetClip.rndNumBtn.gotoAndStop(1);
					targetClip.rndDotBtn.gotoAndStop(3);
					shuffle();
				});											
			}else{
				targetClip.reset_btn.alpha = 0.5;
			}
		}
		private function onmouseOver(eve:MouseEvent =null):void{
			var btn = eve.target
			btn.gotoAndStop(2);
		}
		private function onmouseout(eve:MouseEvent =null):void{
			var btn = eve.target
			btn.gotoAndStop(1);
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData=new XML(e.target.data);
			
			enableBtns(true);			
			reset();
			targetClip.visible = true;
			targetClip.addEventListener(MouseEvent.MOUSE_DOWN,onStageClicked);
		}
		public function reset():void {
			fromRange = 0;
			toRange = xmlData.smallpages.children().length() - 1;
			modes = "rndAnyBtn";
			targetClip.rndAnyBtn.gotoAndStop(2);
			targetClip.rndNumBtn.gotoAndStop(1);
			targetClip.rndDotBtn.gotoAndStop(1);
			updateRangeVal();
			shuffle();
		}
		public function shuffle():void {
			pageArr=[];
			currLeftPage = randomRange(currLeftPage,fromRange,toRange);
				
			if(targetClip.rndDotBtn.currentFrame==3){
				contentType = 0;
			}else if(targetClip.rndNumBtn.currentFrame==3){
				contentType = 1;
			}else{
				contentType = randomRange(contentType,0,1);
			}			
			
			if (targetClip.getChildByName("leftPage")!=null) {
				targetClip.removeChild(targetClip.getChildByName("leftPage"));
			}
			if (targetClip.getChildByName("rightPage")!=null) {
				targetClip.removeChild(targetClip.getChildByName("rightPage"));
			}
			if (targetClip.getChildByName("smallPagesClip")!=null) {
				targetClip.removeChild(targetClip.getChildByName("smallPagesClip"));
			}
			if (targetClip.getChildByName("feedback")!=null) {
				targetClip.removeChild(targetClip.getChildByName("feedback"));
			}
			
			addBigPages();
			addSmallPages();
			loadLeftPage();
			drawFeedback();
		}		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;
			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function addBigPages():void {
			var leftPage:MovieClip = drawPage(Number(xmlData.bigpage.@width), Number(xmlData.bigpage.@height),  Number(xmlData.bigpage.@bgColor), ((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
			leftPage.name="leftPage";
			leftPage.x=Number(xmlData.bigpage.@x);
			leftPage.y=Number(xmlData.bigpage.@y);
			targetClip.addChild(leftPage);

			var rightPage:MovieClip = drawPage(Number(xmlData.bigpage.@width), Number(xmlData.bigpage.@height),  Number(xmlData.bigpage.@bgColor), ((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
			rightPage.name="rightPage";
			rightPage.x=leftPage.x+leftPage.width;
			rightPage.y=leftPage.y;
			rightPage.border.left.visible=false;
			rightPage.bg.alpha=0;
			targetClip.addChild(rightPage);
			targetClip.addEventListener(MouseEvent.MOUSE_UP,onRightPageClicked);
		}		
		private function addSmallPages():void {
			pageArr = [];
			var smallPagesClip:MovieClip = targetClip.getChildByName("smallPagesClip") as MovieClip;
			if(smallPagesClip!=null) targetClip.removeChild(smallPagesClip);
			smallPagesClip = new MovieClip();
			smallPagesClip.name = "smallPagesClip";
			
			var from:Number = Number(targetClip.fromTxt.text);
			var to:Number = Number(targetClip.toTxt.text);
			for (var i:Number=from; i<=to; i++) {
				var numOfContents:Number=xmlData.smallpages.page[i].children().length();
				pageArr.push({id:i,contentType:contentType,contentCount:numOfContents});
				var smallPage:MovieClip = drawPage(Number(xmlData.smallpages.@width), Number(xmlData.smallpages.@height),  Number(xmlData.bigpage.@bgColor), ((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
				smallPage.name="smallPage_"+(pageArr.length-1);
				var newX:Number = 
				smallPage.x=(pageArr.length-1) * (smallPage.width + Number(xmlData.smallpages.@gap));				
				drawPageContent(contentType,i,smallPage);
				smallPage.addEventListener(MouseEvent.MOUSE_DOWN,smallPageClicked);
				smallPagesClip.addChild(smallPage);
			}
			smallPagesClip.x = (xmlData.smallpages.@x.length>0) ? Number(xmlData.smallpages.@x) : (targetClip.boundary.width - smallPagesClip.width)/2;
			smallPagesClip.y = Number(xmlData.smallpages.@y);
			targetClip.addChild(smallPagesClip);
		}
		private function drawPageContent(cType:Number,pageNo:Number,targetPage:MovieClip):void {
			var isSmall:Boolean = (targetPage.name.indexOf("small")>-1) ? true : false;
			var pageCont:MovieClip = new MovieClip();
			pageCont.name="pageCont";
			var numOfContents:Number=xmlData.smallpages.page[pageNo].children().length();
			if (cType==0) {
				var txt:TextField = new TextField();
				txt.name="txt";
				txt.autoSize=TextFieldAutoSize.LEFT;
				txt.selectable=false;
				txt.background=false;
				txt.border=false;
				txt.text=numOfContents.toString();
				var txtFormat:TextFormat = new TextFormat();
				
				var fnt=getDefinitionByName(xmlData.smallpages.@font) as Class;
				var fon:Font=new fnt();
				txtFormat.font = fon.fontName;
			
				txtFormat.bold=true;
				txtFormat.leftMargin=0;
				txtFormat.rightMargin=0;
				txtFormat.size = (isSmall) ? (Number(xmlData.smallpages.@fontSize)/2) : Number(xmlData.smallpages.@fontSize);
				txtFormat.color=uint(xmlData.smallpages.@fontColor);
				txt.setTextFormat(txtFormat);
				txt.embedFonts=true;
				
				pageCont.addChild(txt);
				pageCont.x = (targetPage.width - pageCont.width)/2;
				pageCont.y = (targetPage.height - pageCont.height)/2;
			} else {
				if (numOfContents>0) {
					for (var j:Number=0; j<numOfContents; j++) {
						var cont:MovieClip = new MovieClip();
						cont.name="cont_"+j;
						cont.graphics.lineStyle(Number(xmlData.smallpages.page[pageNo].dot[j].@borderSize), Number(xmlData.smallpages.page[pageNo].dot[j].@borderColor), (Number(xmlData.smallpages.page[pageNo].dot[j].@borderSize)==0)?0:1);
						cont.graphics.beginFill(Number(xmlData.smallpages.page[pageNo].dot[j].@bgColor), 1);
						cont.graphics.drawCircle(0,0,(isSmall) ? (Number(xmlData.smallpages.page[pageNo].dot[j].@radius)/4) : Number(xmlData.smallpages.page[pageNo].dot[j].@radius));
						var xDist:Number=Number(xmlData.smallpages.page[pageNo].dot[j].@x)-Number(xmlData.smallpages.page[pageNo].@x);
						var yDist:Number=Number(xmlData.smallpages.page[pageNo].dot[j].@y)-Number(xmlData.smallpages.page[pageNo].@y);
						if (isSmall) {
							cont.x=xDist;
							cont.y=yDist;
						} else {
							cont.x = 7.2*(xDist/2);
							cont.y = 6.9*(yDist/2);
						}
						pageCont.addChild(cont);

					}
					pageCont.x = (isSmall) ? 0 : 0;
					pageCont.y = (isSmall) ? 0 : 0;
				}
			}
			targetPage.addChild(pageCont);
			targetPage.mouseChildren=false;
		}
		private function drawFeedback():void {
			var feedback:Feedback = new Feedback();
			feedback.name="feedback";
			feedback.x=Number(xmlData.feedback.@x);
			feedback.y=Number(xmlData.feedback.@y);
			feedback.visible=false;
			targetClip.addChild(feedback);
		}
		private function duplicateSmallPage(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height+clone.border.top.height),false);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		private function onStageClicked(e:MouseEvent):void{
			var id:Number = Number(e.target.name.split("_")[1]);
			var dupSmallPage:MovieClip = targetClip.getChildByName("dupSmallPage") as MovieClip;
			if(currRightPage == id){
				return;
			}
			var numOfPages:Number=xmlData.smallpages.children().length();
			var smallPagesClip:MovieClip = targetClip.getChildByName("smallPagesClip") as MovieClip;
			for (var j:Number=0; j<pageArr.length; j++) {
				var smallPage:MovieClip = smallPagesClip.getChildByName("smallPage_"+j) as MovieClip;
				if((smallPagesClip.mouseX >=smallPage.x && smallPagesClip.mouseX <=smallPage.x+smallPage.width) && (smallPagesClip.mouseY >=smallPage.y && smallPagesClip.mouseY <=smallPage.y+smallPage.height)){					
					if(dupSmallPage!=null) targetClip.removeChild(dupSmallPage);
					isDragging = false;					
					smallPage.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));					
					break;
				}
			}
			for(var i=0;i<btnArr.length;i++){
				var btn = btnArr[i];
				if(btn.visible && (targetClip.mouseX >=btn.x && targetClip.mouseX <=btn.x+btn.width) && (targetClip.mouseY >=btn.y && targetClip.mouseY <=btn.y+btn.height)){
					if(dupSmallPage!=null){
						if(btn.name!="settingsBtn")
						targetClip.removeChild(dupSmallPage);						
						btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
					}
					break;
				}
			}			
		}
		private function smallPageClicked(e:MouseEvent):void {
			if (!isDragging) {
				currRightPage=Number(e.target.name.split("_")[1]);				
				var dupSmallPage:MovieClip=duplicateSmallPage(e.target as MovieClip);
				dupSmallPage.name="dupSmallPage";
				dupSmallPage.x = targetClip.mouseX - dupSmallPage.width/2;
				dupSmallPage.y = targetClip.mouseY - dupSmallPage.height/2;
				targetClip.addChild(dupSmallPage);				
				var boundary:Rectangle=new Rectangle(targetClip.x,targetClip.y,(STAGE_WIDTH-85),(STAGE_HEIGHT-180));
				dupSmallPage.startDrag(false,boundary);
			}
		}
		private function onRightPageClicked(e:MouseEvent):void {
			var dupSmallPage:MovieClip=targetClip.getChildByName("dupSmallPage") as MovieClip;
			if (dupSmallPage!=null) {
				var rightPage:MovieClip=targetClip.getChildByName("rightPage") as MovieClip;
				var rect1:Rectangle=dupSmallPage.getBounds(targetClip);
				var rect2:Rectangle=rightPage.getBounds(targetClip);
				if (rect1.intersection(rect2).width!=0&&rect1.intersection(rect2).height!=0) {
					loadRightPage();
				}
			}
		}
		private function loadLeftPage():void {
			var leftPage:MovieClip=targetClip.getChildByName("leftPage") as MovieClip;
			drawPageContent((contentType==0) ? 1 : 0,currLeftPage,leftPage);
		}
		private function loadRightPage():void {
			var dupSmallPage:MovieClip=targetClip.getChildByName("dupSmallPage") as MovieClip;
			dupSmallPage.stopDrag();
			targetClip.removeChild(dupSmallPage);
			var rightPage:MovieClip=targetClip.getChildByName("rightPage") as MovieClip;
			var pageCont:MovieClip=rightPage.getChildByName("pageCont") as MovieClip;
			if (pageCont!=null) {
				rightPage.removeChild(pageCont);
			}
			rightPage.bg.alpha=1;
			drawPageContent(pageArr[currRightPage].contentType,currRightPage,rightPage);
			if (currLeftPage==currRightPage) {
				showFeedback(true);
			} else {
				showFeedback(false);
			}
		}
		private function updateRangeVal(e:MouseEvent=null):void{
			var minValue:Number = 0;
			var maxValue:Number = xmlData.smallpages.children().length()-1;			
			if(e != null){
				var btnName:String = e.target.name;
				switch(btnName){
					case "fromUpBtn":
						if(fromRange<toRange){
							targetClip.fromTxt.text = ++fromRange;
							shuffle();
						}else{
							targetClip.fromTxt.text = fromRange;
						}
					break;
					
					case "fromDownBtn":
						if(fromRange>minValue){
							targetClip.fromTxt.text = --fromRange;
							shuffle();
						}else{
							targetClip.fromTxt.text = fromRange;
						}
						
					break;
					
					case "toUpBtn":
						if(toRange<maxValue){
							targetClip.toTxt.text = ++toRange;
							shuffle();
						}else{
							targetClip.toTxt.text = toRange;
						}
						
					break;
					
					case "toDownBtn":
						if(toRange>fromRange){
							targetClip.toTxt.text = --toRange;
							shuffle();
						}else{
							targetClip.toTxt.text = toRange;
						}						
					break;
				}
			}else{
				targetClip.fromTxt.text = fromRange;
				targetClip.toTxt.text = toRange;
			}			
		}
		private function showFeedback(isCorrect:Boolean):void {
			var feedback:MovieClip=targetClip.getChildByName("feedback") as MovieClip;
			if (isCorrect) {
				feedback.gotoAndStop(2);
			} else {
				feedback.gotoAndStop(1);
			}
			feedback.visible=true;
		}
	}
}