﻿package com
{
	import flash.display.MovieClip;
	import flash.events.*; 
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	public class DotCardCounting{
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var dotsArr:Array;
		private var currPage:Number;
		private var btnNum:Number;
		private var fromRange:Number=1;
		private var toRange:Number=10;
		private var numOfDots:Number = 0;
		
		public function DotCardCounting(target:MovieClip):void{
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			dotsArr = new Array();		
			currPage = -1;
			btnNum = -1;
		}
		public function setUp(url:String):void{
			enableBtns(false);
			loadXML(url);
		}
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max >= min) return min;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}	
			return currRnd;
		}
		private function enableBtns(val:Boolean):void{
			/*if(val){
				for(var i:Number=0;i<10;i++){
					if(i<xmlData.pages.children().length()){
						targetClip.btnClip["btn_"+i].gotoAndStop(1);
						targetClip.btnClip["btn_"+i].visible = true;
						targetClip.btnClip["btn_"+i].buttonMode = true;
						targetClip.btnClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
						targetClip.btnClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
						targetClip.btnClip["btn_"+i].addEventListener(MouseEvent.CLICK,onBtnClicked);
					}else{
						targetClip.btnClip["btn_"+i].visible = false;
					}
				}
			}*/
			
			
			targetClip.rndBtn.fromUpBtn.buttonMode = true;
			targetClip.rndBtn.fromDownBtn.buttonMode = true;
			targetClip.rndBtn.toUpBtn.buttonMode = true;
			targetClip.rndBtn.toDownBtn.buttonMode = true;
			targetClip.rndBtn.fromUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
			targetClip.rndBtn.fromDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
			targetClip.rndBtn.toUpBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
			targetClip.rndBtn.toDownBtn.addEventListener(MouseEvent.CLICK,updateRangeVal);
			updateRangeVal(); 
			
			
			
			
			/*targetClip.selectNumBtn.enabled = val;	
			targetClip.btnClip.mouseChildren = val;*/
		}
		/*private function onBtnClicked(e:MouseEvent):void{
			//if(btnNum != -1) targetClip.btnClip["btn_"+btnNum].gotoAndStop(1);
			var button
			btnNum = Number(e.target.name.split("_")[1]);
			for (var i:int = 1; i <= 10; i++) {
						button = targetClip.btnClip.getChildByName("btn_" + (i-1)) as MovieClip;
					button.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					button.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
					button.gotoAndStop(1);
					if ( btnNum == (i-1) ) {
						button.gotoAndStop(3);
						button.removeEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
						button.removeEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
					}
			}
			reDraw(btnNum);
			targetClip.btnClip.visible = false;
			
		}*/
		
		
		
		
		private function loadXML(path:String){
			var urlRequest:URLRequest = new URLRequest(path);
			var urlLoader:URLLoader = new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void{
			xmlData = new XML(e.target.data);
			
			
			/*targetClip.selectNumBtn.buttonMode = true;
			targetClip.selectNumBtn.mouseChildren = false;
			targetClip.selectNumBtn.addEventListener(MouseEvent.MOUSE_OVER,onMouseOver);
			targetClip.selectNumBtn.addEventListener(MouseEvent.MOUSE_OUT,onMouseOut);
			targetClip.selectNumBtn.addEventListener(MouseEvent.MOUSE_DOWN,onMousedown);
			targetClip.selectNumBtn.addEventListener(MouseEvent.MOUSE_UP,onMouseup);
			targetClip.selectNumBtn.addEventListener(MouseEvent.CLICK,function(){targetClip.btnClip.visible = !targetClip.btnClip.visible;});*/
			targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
				currPage = randomRange(currPage,0,xmlData.pages.children().length()-1);
				reset();
			});
			enableBtns(true);
			targetClip.reset_btn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			targetClip.visible = true;
		}		
		private function onMouseOver(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(2)
		}
		private function onMouseOut(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(1)
		}

		private function onMousedown(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(3)
		}
		private function onMouseup(eve:MouseEvent =null):void{
			var button = eve.target
			button.gotoAndStop(1)
		}
		private function reset():void{			
					
			var button
			/*for (var i:int = 1; i <= 10; i++) {
					button = targetClip.btnClip.getChildByName("btn_" + (i-1)) as MovieClip;
					button.addEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
					button.addEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
					button.gotoAndStop(1);
					if ( currPage == (i-1) ) {
						button.gotoAndStop(3);
						button.removeEventListener(MouseEvent.MOUSE_OVER, onMouseOver);
						button.removeEventListener(MouseEvent.MOUSE_OUT, onMouseOut);
					}
			}
			
			targetClip.btnClip.visible = false;*/
			
			//@@
			currPage = randomRange(currPage,fromRange,toRange);
			
			
			dotsArr = [];
			if(targetClip.getChildByName("page")!=null) targetClip.removeChild(targetClip.getChildByName("page"));
			if(targetClip.getChildByName("answerBg")!=null) targetClip.removeChild(targetClip.getChildByName("answerBg"));
			if(targetClip.getChildByName("feedback")!=null) targetClip.removeChild(targetClip.getChildByName("feedback"));
			
			addBigPages();
			drawPageContent();
			drawAnswerPage();
			drawFeedback();	
		}
		public function reDraw(pageNo:Number):void{
			currPage = pageNo;
			reset();
		}
		private function resizePage(page:MovieClip, w:Number, h:Number):void{
			page.bg.x = 0;
			page.bg.y = 0;
			page.bg.width = w;
			page.bg.height = h;
				
			//if(page.border.visible){				
				page.border.right.height = h;
				page.border.top.width = w;
				page.border.left.height = h;				
				page.border.bottom.width = w;				
				
				page.border.left.x = 0;
				page.border.left.y = 0;
				page.border.top.x = 0;
				page.border.top.y = 0;
				
				page.border.right.x = page.border.top.x + page.border.top.width - page.border.right.width;
				page.border.right.y = 0;			
				page.border.bottom.x = 0;
				page.border.bottom.y = page.border.left.y + page.border.left.height - page.border.bottom.height;
			//}			
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip{
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
   			pageColorTrans.color = fillColor;
		    page.bg.transform.colorTransform = pageColorTrans;
			page.bg.alpha = fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if(page.border.visible){
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color = borderColor;
				page.border.transform.colorTransform = borderColorTrans;
				
				page.border.left.width = borderSize;				
				page.border.right.width = borderSize;
				page.border.top.height = borderSize;
				page.border.bottom.height = borderSize;
			}
			resizePage(page,w,h);
			return page;
		}		
		private function addBigPages():void{
			var page:MovieClip = drawPage(Number(xmlData.bigpage.@width), Number(xmlData.bigpage.@height), Number(xmlData.bigpage.@bgColor),((xmlData.bigpage.@bgColor=="")?0:1), Number(xmlData.bigpage.@borderSize), Number(xmlData.bigpage.@borderColor));
			page.name = "page";
			page.x = Number(xmlData.bigpage.@x);
			page.y = Number(xmlData.bigpage.@y); 
			targetClip.addChild(page);
		}		
		private function drawPageContent():void{
			var page:MovieClip = targetClip.getChildByName("page") as MovieClip;
			var pageContent:MovieClip = new MovieClip();
			pageContent.name = "pageContent";
			numOfDots = xmlData.pages.page[currPage-1].children().length();
			
			for (var i:Number = 0; i < numOfDots; i++) {
				var dot = new ball();
				dot.name = "dot_" + i;
				
				/*var dot:MovieClip = new MovieClip();
				dot.name = "dot_"+i;
				dot.graphics.lineStyle(Number(xmlData.pages.page[currPage].dot[i].@borderSize), Number(xmlData.pages.page[currPage].dot[i].@borderColor), (Number(xmlData.pages.page[currPage].dot[i].@borderSize)==0)?0:1);
				dot.graphics.beginFill(Number(xmlData.pages.page[currPage].dot[i].@bgColor), 1);
				dot.graphics.drawCircle(0,0,Number(xmlData.pages.page[currPage].dot[i].@radius));*/	
				
				dot.x = Number(xmlData.pages.page[currPage-1].dot[i].@x) - page.x;
				dot.y =  Number(xmlData.pages.page[currPage-1].dot[i].@y) - page.y;
				dot.alpha = 0.2;
				
				
				switch (currPage) 
				{
					case 1:
					case 4:
					case 7:
					case 10:
						dot.gotoAndStop(1);
					break;
					
					case 2:
					case 5:
					case 8:
						dot.gotoAndStop(2);
					break;
					
					case 3:
					case 6:
					case 9:
						dot.gotoAndStop(3);
					break;
					default:
				}
				
				
				
				dot.addEventListener(MouseEvent.CLICK, onDotClicked);
				
				pageContent.addChild(dot);				
				dotsArr.push({id:i,clicked:false});
			}
			page.addChild(pageContent);
		}
		private function drawAnswerPage():void{
			var answerBg:MovieClip = drawPage(100, 100, Number(xmlData.answer.@bgColor), ((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
			answerBg.name = "answerBg";
			
			var answerTxt:TextField = new TextField();
			answerTxt.name = "answerTxt";
			answerTxt.selectable = false;
			answerTxt.background = false;
			answerTxt.border = false;
			answerTxt.autoSize = TextFieldAutoSize.CENTER;			
			answerBg.addChild(answerTxt);
			targetClip.addChild(answerBg);
			
			showResult(-1);
		}
		private function drawFeedback():void{
			var feedback:Feedback = new Feedback();
			feedback.name = "feedback";	
			feedback.x = Number(xmlData.feedback.@x);
			feedback.y = Number(xmlData.feedback.@y);
			feedback.visible = false;
			targetClip.addChild(feedback);
		}		
		private function onDotClicked(e:MouseEvent):void{
			var id:Number = Number(e.target.name.split("_")[1]);
			var clickedCnt:Number = 0;
			dotsArr[id].clicked = !dotsArr[id].clicked;
			e.target.alpha = (dotsArr[id].clicked) ? 1 : 0.2;
			for(var i:Number=0;i<dotsArr.length;i++){
				if(dotsArr[i].clicked){
					clickedCnt++;
				}
			}
			showResult(clickedCnt);			
			if(clickedCnt == numOfDots){
				showFeedback(true);
			}else{
				showFeedback(false);
			}
		}		
		private function showResult(val:Number):void{
			numOfDots = xmlData.pages.page[currPage-1].children().length();
			var page:MovieClip = targetClip.getChildByName("page") as MovieClip;
			var answerBg:MovieClip = targetClip.getChildByName("answerBg") as MovieClip;
			var answerTxt:TextField = answerBg.getChildByName("answerTxt") as TextField;
			if(val == -1){
				answerBg.bg.alpha = 0;
				answerTxt.text = "0";
				answerTxt.visible = false;
			}else{
				answerTxt.visible = true;
				answerBg.bg.alpha = ((xmlData.answer.@bgColor=="") ? 0 : 1);
				answerTxt.text = val.toString();
			}
			var txtFormat:TextFormat = new TextFormat();
			var fnt=getDefinitionByName(xmlData.answer.@fontId) as Class;
			var fon:Font=new fnt();
			txtFormat.font = fon.fontName;
			txtFormat.bold = true;
			
			txtFormat.size = Number(xmlData.answer.@fontSize);
			txtFormat.color = uint(xmlData.answer.@fontColor);			
			
			answerTxt.embedFonts=true;
					
			if(val == numOfDots){
				txtFormat.leftMargin = 0;
				txtFormat.rightMargin = 0;
				txtFormat.size = Number(xmlData.answer.@fontSize) * 4;
				answerTxt.setTextFormat(txtFormat);	
				resizePage(answerBg,page.width,page.height);
				answerTxt.x = (answerBg.width - answerTxt.width)/2;
				answerTxt.y = (answerBg.height - answerTxt.height)/2;				
				if(numOfDots>9) answerTxt.x = answerTxt.x - 15;
				answerBg.x = page.x + page.width + 40;
			}else{						
				txtFormat.leftMargin = 20;
				txtFormat.rightMargin = 20;				
				txtFormat.size = Number(xmlData.answer.@fontSize);
				answerTxt.setTextFormat(txtFormat);	
				resizePage(answerBg,answerTxt.width,answerTxt.height + 20);
				answerTxt.x = 0;
				answerTxt.y = 10;
				answerBg.x = page.x + page.width + 110;
			}			
			answerBg.y = page.y + (page.height - answerBg.height)/2;
		}
		private function showFeedback(isCorrect:Boolean):void{
			var feedback:MovieClip = targetClip.getChildByName("feedback") as MovieClip;
			if(isCorrect){
				feedback.gotoAndStop(2);
			}else{
				feedback.gotoAndStop(1);
			}
			feedback.visible = isCorrect;
		}	
		
		/////////////////////////////////////		
		private function updateRangeVal(e:MouseEvent=null):void{
			var minValue:Number = 1;
			var maxValue:Number = 10;	
			if(e != null){
				var btnName:String = e.target.name;
				switch(btnName){
					case "fromUpBtn":
						if(fromRange<toRange){
							targetClip.rndBtn.fromTxt.text = ++fromRange;
							reset();
						}else{
							targetClip.rndBtn.fromTxt.text = fromRange;
						}
					break;
					
					case "fromDownBtn":
						if(fromRange>minValue){
							targetClip.rndBtn.fromTxt.text = --fromRange;
							reset();
						}else{
							targetClip.rndBtn.fromTxt.text = fromRange;
						}
					break;
					
					case "toUpBtn":
						if(toRange<maxValue){
							targetClip.rndBtn.toTxt.text = ++toRange;
							reset();
						}else{
							targetClip.rndBtn.toTxt.text = toRange;
						}
					break;
					
					case "toDownBtn":
						if(toRange>fromRange){
							targetClip.rndBtn.toTxt.text = --toRange;
							reset();
						}else{
							targetClip.rndBtn.toTxt.text = toRange;
						}
					break;
				}
			}else{
				targetClip.rndBtn.fromTxt.text = fromRange;
				targetClip.rndBtn.toTxt.text = toRange;
			}			
		}		
	}
}